/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package Applet;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class MtgColorButton extends JButton implements ActionListener, MouseListener {
  private AppletMathGraph32 appletMere;
  private static Insets insets = new Insets(0,0,0,0);
  public Color couleur = Color.BLACK; // la couleur du bouton
  
  /** Creates a new instance of JMtgColorButton */
  public MtgColorButton(AppletMathGraph32 appletMereInit) {
    super();
    appletMere = appletMereInit;
    setMargin(insets);
    setBackground(appletMere.paneLow.getBackground());
    setToolTipText(AppletMathGraph32.messages.getString("toolTip27"));
    setPreferredSize(new Dimension(56,24));
    addActionListener(this);
    addMouseListener(this);
  }

  public void actionPerformed(ActionEvent e) {
    JColorChooser cs = appletMere.colorChooser;
    cs.setColor(couleur);
    JDialog dialog = JColorChooser.createDialog(null, AppletMathGraph32.getString("toolTip27"), true, cs,
            null, null);
    dialog.setVisible(true);
    couleur = cs.getColor();
  }

	public void paint(Graphics g) {
  	Graphics2D g2D = (Graphics2D)g;
  	setSize(getPreferredSize());
  	setOpaque(false);
  	super.paint(g); // Pour que le rectangle de fond soit transparent
  	g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    Dimension rect = getSize();
		g2D.setColor(couleur);
    g2D .fillOval(4, 4, rect.width - 9, rect.height - 9);
	}

	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseEntered(MouseEvent e) {
    if (getCursor() != AppletMathGraph32.defaultCursor) setCursor(AppletMathGraph32.defaultCursor);				
	}

	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}
}
