/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import Applet.AppletMathGraph32;

@SuppressWarnings("serial")
public class ChoixModificationImageDlg extends MtgDlg {
  private javax.swing.JButton btnCancel;
  private javax.swing.JButton btnOK;
  private javax.swing.ButtonGroup btnGroup;
  private JRadioButton radioModificationMultiple; // Si l'utilisateur fait le choix que la modification d'une image s'appliquera
	//  toutes les autres images
	private JRadioButton radioModificationUnique; // Si l'utilisateur fait le choix que la modification d'une image s'appliquera
	// la seule image clique
	private JLabel label1;
	private JLabel label2;
	private JLabel label3;
  private javax.swing.JPanel paneLeft;
  private javax.swing.JPanel paneRight;
  private javax.swing.JPanel panePrincipal;	
	/** Constructeur */
	public ChoixModificationImageDlg(AppletMathGraph32 appletInit) {
    super(getString("ch103"), true, appletInit);
    label1 = new JLabel(getString("choixModificationImageDlg1"), JLabel.LEFT);
    label2 = new JLabel(getString("choixModificationImageDlg2"), JLabel.LEFT);
    label3 = new JLabel(getString("choixModificationImageDlg3"), JLabel.LEFT);
    radioModificationMultiple = new javax.swing.JRadioButton(getString("choixModificationImageDlg4"));
    radioModificationUnique = new javax.swing.JRadioButton(getString("choixModificationImageDlg5"));
    paneLeft = new javax.swing.JPanel();
    paneRight = new javax.swing.JPanel();
    panePrincipal = new javax.swing.JPanel();
    btnOK = new javax.swing.JButton(getString("btnOK"));
    btnOK.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnOKActionPerformed(evt);
      }
    });    
    btnCancel = new javax.swing.JButton(getString("btnCancel"));
    btnCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnCancelActionPerformed(evt);
      }
    });
    btnOK.setMaximumSize(btnCancel.getPreferredSize());
    btnGroup = new ButtonGroup();
    btnGroup.add(radioModificationMultiple);
    btnGroup.add(radioModificationUnique);
    paneLeft.setLayout(new BoxLayout(paneLeft, BoxLayout.Y_AXIS));
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneLeft.add(label1);
    paneLeft.add(label2);
    paneLeft.add(label3);
    paneLeft.add(radioModificationMultiple);
    paneLeft.add(radioModificationUnique);
    radioModificationMultiple.setSelected(true);
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    panePrincipal.setLayout(new FlowLayout());
    panePrincipal.add(paneLeft);
    panePrincipal.add(paneRight);
    setContentPane(panePrincipal);
    pack();        
	}
  private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) { 
  	setRetourOK(false);
    dispose ();
  }                                         

  private void btnOKActionPerformed(java.awt.event.ActionEvent evt) {                                      
    // Si la rponse est valide, on ferme la boite de dialogue sans la dtruire.
    //setVisible(false); 
    dispose();
    //La boite de dialogue existera toujours ce qui permettra de connaitre le contneu
    // de retourOK
    setRetourOK(true);
  }
  
  public final boolean getModificationMultiple() {
  	return radioModificationMultiple.isSelected();
  }

}
