/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.io.*;

import java.util.ListIterator;

import types.Int;

import entreesSorties.MathGraphDataInputStream;
import entreesSorties.MathGraphDataOutputStream;

@SuppressWarnings("serial")
public class CSousListeObjets extends CListeObjets {

  /** Creates new CSousListeAction */
  public CSousListeObjets() {
  }

	public void remplacePoint(CPointAncetre ancienPoint,
			CPointAncetre nouveauPoint) {
		ListIterator<CElementBase> li = listIterator();
		while (li.hasNext()) {
			CElementBase elb = li.next();
			if (elb == ancienPoint) set(indexOf(ancienPoint), nouveauPoint);
		}
	}
  
  /* Lecture depuis un flux C++ */
  public void chargeDepuisFlux(MathGraphDataInputStream inps, CListeObjets listeProprietaire) throws IOException {
    int nombreObjets = inps.readCCount();
    for (int i = 0; i < nombreObjets; i++) {// Octets inutiles car pas d'objet CActionSousListe
      Int nVer = new Int();
      @SuppressWarnings("unused")
			String ch = inps.readNomClasse(nVer, listeProprietaire.numeroVersion);
      @SuppressWarnings("unused")
      int k;
			if (nVer.getValue() == 1) k = inps.readCInt();
			else k = inps.readByte();
      int ind = inps.readCInt();
      CElementBase elb = (CElementBase) (listeProprietaire.get(ind));
      add(elb);
    }
  }
 
  /* Lecture depuis un flux java */
  public void read(MathGraphDataInputStream inps, CListeObjets listeProprietaire) throws IOException {
    int nombreObjets = inps.readInt();
    for (int i = 0; i < nombreObjets; i++) {
      int ind = inps.readInt();
      CElementBase elb = (CElementBase) (listeProprietaire.get(ind));
      add(elb);
    }
  }
  
  /* Enregistrement dans un flux java */
  public void write(MathGraphDataOutputStream oups, CListeObjets listeProprietaire) throws IOException {
    oups.writeInt(size());
    ListIterator<CElementBase> li = listIterator();
    while(li.hasNext()) {
      CElementBase elb = (CElementBase) (li.next());
      oups.writeInt(listeProprietaire.indexOf(elb));
    }
  } 
}
