/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


package outils;

import Applet.*;
import java.util.ListIterator;

import objets.*;

import types.*;

/**
 *
 * @author Yves
 */
public class OutilCapture extends Outil{
  
  /** Creates a new instance of OutilCapture */
  public OutilCapture(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false, AppletMathGraph32.iconCapture);
  }
  /* L'outil capture sera actif pour toutes les figures
  public int idMenu() {
    return 32809;
  }
   * */
  
  public String toolTip() {
    return getString("toolTip4");
  }
  
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    designationDe(NatureObjet.NToutPoint);
    //On ajoute  la liste d'exclusion de dsignation tous les points
    // mobiles punaiss
    CListeObjets list = appletMere.listePr;
    ListIterator<CElementBase> li = list.listIterator();
    while(li.hasNext()) {
      CElementBase elb = (CElementBase) li.next();
      long nat = elb.getNature();
      if ((nat & NatureObjet.NPointMobile) != 0) {
        if (!((CPointAncetrePointsMobiles) elb).estLibre()) 
          appletMere.listeExclusionDesignation.add(elb);
      }
    }
    appletMere.outilPointageActif = appletMere.outilPointageCapture;
    appletMere.indication(getString("capture1"));
  }
  
}
