/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Outil de cration d'une droite parallle
 */
package outils;

import objets.*;
import Applet.*;

public class OutilDtPar extends OutilParDtPt {
  
  /** Creates a new instance of OutilDtPar */
  public OutilDtPar(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, AppletMathGraph32.iconCreerDroiteParallele);
  }
  
  public int idMenu() {
    return 32787;
  }
  
  public String toolTip() {
    return getString("toolTip9");
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CDroiteParallele pt = new CDroiteParallele(appletMere.listePr, null, false,
       appletMere.couleurActive(), appletMere.styleTraitActif(), point1, droite1, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil8"));
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CDroiteParallele dt = new CDroiteParallele(appletMere.listeObjetsVisuels, null, false,
    		appletMere.couleurActive(), appletMere.styleTraitActif(), appletMere.pointSouris, droite1, 2);
    appletMere.listeObjetsVisuels.add(dt);
  }

  /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */
          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return getString("parallele1");
      case 2 : return getString("parallele2");
      default: return "";
    }
  }
  
}
