/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.*;
import types.*;
import Applet.*;

/**
 *
 * @author Yves
 */
public class OutilMed extends OutilPar2pts {
  
  /** Creates a new instance of OutilMed */
  public OutilMed(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, AppletMathGraph32.iconCreerDroiteMediatrice);
  }
  
  public int idMenu() {
    return 32790;
  }
  
  public String toolTip() {
    return getString("toolTip12");
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CMediatrice pt = new CMediatrice(appletMere.listePr, null, false,
      appletMere.couleurActive(), appletMere.styleTraitActif(), point1, point2, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil11"));
    select();
  }
  /* Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CListeObjets liste = appletMere.listeObjetsVisuels;
    CMilieu ptm = new CMilieu(liste, null, false, Couleur.TraduitCouleur(1), MotifPoint.petitRond,
      point1, appletMere.pointSouris);
    ptm.cache();
    liste.add(ptm);
  	// On cre deux segments en pointills
  	CSegment pts1 = new CSegment(liste, null, false, point1, ptm);
    liste.add(pts1);
  	CSegment pts2 = new CSegment(liste, null, false, ptm, appletMere.pointSouris);
    liste.add(pts2);
    // On cre une marque de segment pour les deux
    CMarqueSegment ptMarque1 = new CMarqueSegment(liste, null, false,
      Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts1);
    liste.add(ptMarque1); 
    CMarqueSegment ptMarque2 = new CMarqueSegment(liste, null, false,
       Couleur.TraduitCouleur(1), false, StyleTrait.traitEpais,
      MotifMarqueSegment.MarqueSimple, pts2);
    liste.add(ptMarque2);
    // On cre une perpendiculaire plutt qu'une mdiatrice pour pouvoir lui adjoindre
    // une marque d'angle droit
    CDroitePerpendiculaire ptPer = new CDroitePerpendiculaire(liste, null, false,
      appletMere.couleurActive(), StyleTrait.traitPointille, ptm, pts1, 2);
    appletMere.listeObjetsVisuels.add(ptPer);
    // Cration de la marque d'angle droit
    CMarqueAngleDroit marque = new CMarqueAngleDroit(liste, null, false, ptPer);
    appletMere.listeObjetsVisuels.add(marque);
  }
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return getString("mediatrice1");
      case 2 : return getString("mediatrice2");
      default: return "";
    }
  }
}
