/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;
import Applet.*;
import java.awt.*;
import java.awt.geom.Point2D;

import objets.*;

import types.*;

/**
 *
 * @author Yves
 */
public class OutilPtLie extends Outil {
  private CElementGraphique elementPourLiaison;
  private int xclic;
  private int yclic;
  
  /** Creates a new instance of OutilPtLie */
  public OutilPtLie(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false, AppletMathGraph32.iconCreerPointLie);
  }
  
  public int idMenu() {
    return 32800;
  }
  
  public String toolTip() {
    return getString("toolTip15");
  }
    
  /** Appel lorsque l'outil est slectionn */
  public void select() {
    super.select();
    elementPourLiaison = null;
    appletMere.outilPointageActif = appletMere.outilPointageCre;
    designationDe(NatureObjet.NTouteDroite + NatureObjet.NToutCercle + NatureObjet.NPolygone
      + NatureObjet.NLigneBrisee);
    appletMere.indication(getString("pointLie1"));
  }

  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    if (elementPourLiaison == null) {
      elementPourLiaison = elg;
      xclic = pointClique.x;
      yclic = pointClique.y;
      creeObjet();
    }
  }
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    Doub pointabs = new Doub();
    Point2D.Double pointres = new Point2D.Double();
    CPointLie ptp = null;
    CListeObjets liste = appletMere.listePr;    
    long nat = elementPourLiaison.getNature();
    if ((nat & NatureObjet.NTouteDroite) != 0) {
      ptp = new CPointLieDroite(liste, null, false, appletMere.couleurActive(),
        false, 0d, 0d, false, "", 2, MotifPoint.petitRond, true, 0,
        (CDroiteAncetre) elementPourLiaison, false);
    }
    else {
      if ((nat & NatureObjet.NToutCercle) != 0) {
      ptp = new CPointLieCercle(liste, null, false, appletMere.couleurActive(),
        false, 0d, 0d, false, "", 2, MotifPoint.petitRond, true, 0,
        (CCercle) elementPourLiaison, false);       
      }
      else {
        if (( nat == NatureObjet.NPolygone) || (nat ==NatureObjet.NLigneBrisee)) {
          ptp = new CPointLieLigne(liste, null, false, appletMere.couleurActive(),
            false, 0d, 0d, false, "", 2, MotifPoint.petitRond, true, 0,
            (CLignePolygonaleAncetre) elementPourLiaison, false);              
        }
      }
    }
    ptp.testDeplacement(appletMere.dimf, xclic, yclic, pointres, pointabs);
    ptp.donneAbscisse(pointabs.getValue());
    if (appletMere.ajouteElementAvecVerification(ptp))
      appletMere.gestionnaire.enregistreFigureEnCours(getString("chaineOutil2"));
    appletMere.repaintFigureSansCalcul();
    select();
  }
}
